package dynarray;

import java.util.List;
import java.util.function.Function;

import linearpub.DynamicList;

public class DynamicArray<E> implements DynamicList<E> {

	//---------------------------------
	// Instance Variables

	private E[] fixedArray; //sensitive ivar (access only via privateGetFixedArray and privateSetFixedArray)
	private double growthFactor;
	private int _size;
	private int initialCapacity;

	//---------------------------------
	// Public Constructors

	//--------------------------------------------------------------
	//Public Constructors

	//Returns a new empty DynamicArray
	//with defaults initCapacity=10 and growthFactor=2
	public static <E> DynamicArray<E> newEmpty() {
		return new DynamicArray<>(10, 2);
	}

	public static <E> DynamicArray<E> fromCapacityGrowthFactor(int anInitialCapacity, double aGrowthFactor) {
		return new DynamicArray<>(anInitialCapacity, aGrowthFactor);
	}

	//--------------------------------------------------------------
	//Private (Classic) Constructors

	private DynamicArray(int anInitialCapacity, double aGrowthFactor) {
		this.initialCapacity = anInitialCapacity;
		this.growthFactor = aGrowthFactor;
		this.reset();
	}

	//--------------------------------------------------------------
	//Construction Helpers
	
	private void reset() {
		this._size = 0;
		this.fixedArray = this.newFixedArray(this.initialCapacity);
	}

	@SuppressWarnings("unchecked")
	private E[] newFixedArray(int aSize) {
		return (E[]) new Object[aSize];
	}

	//---------------------------------
	// Private Constructors

	//---------------------------------
	// Public Instance Variables Per DynamicList ADT

	@Override
	public int size() {
		return this._size;
	}

	@Override
	public boolean isEmpty() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public E get(int index) {
		if (index < 0 || index >= this.size())
			throw new RuntimeException("(get) Attempt to access element in empty list");
		return this.fixedArray[index];
	}

	@Override
	public DynamicList<E> subList(int start, int stop) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public E first() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public E last() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int find(Function<E, Boolean> searchFct) {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public void addFirst(E newElem) {
		// TODO Auto-generated method stub

	}

	@Override
	public void addLast(E newElem) {
		//Add the passed arg "newElem" to end of list
		if (!this.hasCapacity())
		    this.grow();
		this.fixedArray[this.size()] = newElem;
		this._size++;
	}

	@Override
	public void add(E newElem) {
		this.addLast(newElem);
	}

	@Override
	public void addAll(DynamicList<E> otherDynList) {
		// TODO Auto-generated method stub

	}

	@Override
	public E set(int index, E newElem) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void insert(int insertIndex, E newElem) {
		// TODO Auto-generated method stub

	}

	@Override
	public E removeFirst() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public E removeLast() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void removeAll() {
		// TODO Auto-generated method stub

	}

	@Override
	public E removeIndex(int index) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public E remove(Function<E, Boolean> searchFct) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<E> toNativeList() {
		// TODO Auto-generated method stub
		return null;
	}
	
	//----------------------------------------
	//Helpers
	
	private boolean hasCapacity() {
		// Return true if our capacity is greater than our size
		// i.e. if we have excess capacity
		return this.getCapacity() > this.size();
	}

	private int getCapacity() {
		return this.fixedArray.length;
	}	
	
	private void grow() {
		// Grow (increase) our capacity by factoring our
		//current capacity by the input param "growthFactor"
		// In this method var "fa" will be the new fixed array
		this.growCapacityTo((int)Math.round(getCapacity() * this.growthFactor));
	}

	private void growCapacityTo(int newCapacity) {
		// Grow (increase) our capacity to "newCapacity"
		// Construct new fixed array
		// Copy existing elements into new fixed array
		E[] oldFixedArray = this.fixedArray;
		E[] newFixedArray = this.newFixedArray(newCapacity);
		//Copy
		for (int i = 0; i < this.size(); i++)
			newFixedArray[i] = oldFixedArray[i];
		this.fixedArray = newFixedArray;
	}	
	
}
